/*
 * Sixth - System for data storage, computation, exploration and interaction.
 * Copyright ©2012-2016, Svjatoslav Agejenko, svjatoslav@svjatoslav.eu
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of version 3 of the GNU Lesser General Public License
 * or later as published by the Free Software Foundation.
 */

package eu.svjatoslav.sixth.e3d.examples.launcher;

import javax.swing.*;
import java.awt.*;

class LauncherFrame extends javax.swing.JFrame {

    private static final long serialVersionUID = -3679656169594556137L;

    private LauncherFrame() {
        super();
        initGUI();

    }

    /**
     * Auto-generated main method to display this JFrame
     */
    public static void main(final String[] args) {
        SwingUtilities.invokeLater(() -> {
            final LauncherFrame inst = new LauncherFrame();
            final BorderLayout instLayout = new BorderLayout();
            inst.setLocationRelativeTo(null);
            inst.setVisible(true);
            inst.getContentPane().setLayout(instLayout);
        });
    }

    private void initGUI() {
        getContentPane().add(new MenuPanel());
        pack();
        setSize(390, 300);
    }

}
